moSetGetAmount = {};

function moSetGetAmount:getNoFoundSiloAmount(k)	
	if moFillTypes[k] == nil then return false;end; ---SchutzFunktion SoilMod
	local farmSilo = moGeneralSettings.multiFarmSilo;
	local desc = Fillable.fillTypeIndexToDesc[k];
	if desc == nil then  return false;end;
	local amount = Utils.getNoNil(g_currentMission:getSiloAmount(k), 0);
	local pal = 0;
	function getAmount(checkAmount, fruitsDoubleNames)
		if checkAmount ~= nil then
			return checkAmount;
		end;
		if not fruitsDoubleNames then
			amount = 0;
		end;
		return 0;
	end;	
	moFillTypes[k].siloAmount[farmSilo] = getAmount(amount, false);		
	--new FillablePalettSellTriger2
	if desc.name == "treeSaplings" then
		amount, pal = moSetGetAmount:getNoItemAmount(self, k, "SaplingPallet");
		moFillTypes[k].siloAmount[farmSilo] = amount;
		if moPalFillTypes[k] == nil then moPalFillTypes[k] = {};end;
		moPalFillTypes[k].pal = pal;
		if amount > 0.9 then return true;else return false;end;
	end;
	if desc.name == "wool" and moPalFillTypes[k] == nil then moPalFillTypes[k] = {};end;	
	if moPalFillTypes[k] ~= nil and desc.name ~= "treeSaplings" then
		amount, pal = moSetGetAmount:getNoItemAmount(self, k, "FillablePallet");
		moFillTypes[k].siloAmount[farmSilo] = amount;
		if moPalFillTypes[k] == nil then moPalFillTypes[k] = {};end;
		moPalFillTypes[k].pal = pal;
		if amount > 0.9 then 
			return true;
		elseif desc.name ~= "wool" then
			return false;		
		end;		
	end;
	--new FillablePalettSellTriger2
	--new fix straw grass windrow... double	
	function setTotalAmount(splitFruits, masterFruit)
		local descMasterFruit = Fillable.fillTypeNameToDesc[tostring(masterFruit)];			
		for k, v in pairs(splitFruits) do
			if v ~= nil and string.len(v) > 1 then						
				local descFruit = Fillable.fillTypeNameToDesc[v];
				local amountTemp = Utils.getNoNil(g_currentMission:getSiloAmount(descFruit.index), 0);
				if v ~= tostring(masterFruit) then
					moFillTypes[descFruit.index].siloAmount[farmSilo] = 0;
				end;
				amount = amount+getAmount(amountTemp, true);
			end;
		end;			
	end;
	if not moGeneralSettings.fruitsDoubleNames then		
		if moFillTypes[k].grass and desc.name == tostring(moGeneralSettings.masterGrassFruit) then
			local splitGrassFruits = Utils.splitString(" ", moGeneralSettings.grassFruits);
			amount = 0;
			setTotalAmount(splitGrassFruits, desc.name);
			moFillTypes[k].siloAmount[farmSilo] = amount;				
			if amount > 0.9 then return true;else return false;end;
		elseif moFillTypes[k].hay and desc.name == tostring(moGeneralSettings.masterHayFruit) then
			local splitHayFruits = Utils.splitString(" ", moGeneralSettings.hayFruits);
			amount = 0;
			setTotalAmount(splitHayFruits, desc.name);
			moFillTypes[k].siloAmount[farmSilo] = amount;				
			if amount > 0.9 then return true;else return false;end;							
		elseif moFillTypes[k].windrow and desc.name == tostring(moGeneralSettings.masterWindrowFruit) then
			local splitWindrowFruits = Utils.splitString(" ", moGeneralSettings.windrowFruits);
			amount = 0;
			setTotalAmount(splitWindrowFruits, desc.name);
			moFillTypes[k].siloAmount[farmSilo] = amount;				
			if amount > 0.9 then return true;else return false;end;						
		elseif moFillTypes[k].kalk and desc.name == tostring(moGeneralSettings.masterKalkFruit) then
			local splitKalkFruits = Utils.splitString(" ", moGeneralSettings.kalkFruits);
			amount = 0;
			setTotalAmount(splitKalkFruits, desc.name);
			moFillTypes[k].siloAmount[farmSilo] = amount;				
			if amount > 0.9 then return true;else return false;end;			
		end;
	end;
	--new fix straw grass windrow.. double
	
	local animals = g_currentMission.husbandries;
	if animals ~= nil then
		if desc.name == "wool" and animals.sheep ~= nil and animals.sheep.currentPallet ~= nil then
			--local woolAmount = animals.sheep.currentPalletFillPercentage;
			local woolAmount = animals.sheep.currentPallet.fillLevel;
			if woolAmount ~= nil and woolAmount >= 0.9 then			
				moFillTypes[k].siloAmount[farmSilo] = woolAmount;				
				return true;
			end;
		end;
		if desc.name == "milk" and animals.cow ~= nil then
			local milkRobot = animals.cow.fillLevelMilk;
			if milkRobot ~= nil and milkRobot >= 0.9 then			
				moFillTypes[k].siloAmount[farmSilo] = milkRobot;
				return true;
			end;
		end;				
	end;
	if string.len(moGeneralSettings.foundAnimals) > 1 and string.find(moGeneralSettings.foundAnimals, desc.name.. " ") then			
		if desc.name ~= "cow" and desc.name ~= "sheep" and desc.name ~= "chicken" then			
			if #moMapObjects.sr > 0 then				
				local foundFillAnimal = false;
				for key, mapObject in pairs(moMapObjects.sr) do
					if key ~= nil and mapObject.name == desc.name then						
						local numAmountMod = 0;
						local objectTable = moMapObjects.sr[key];
						if objectTable.numSchweine ~= nil then numAmountMod = objectTable.numSchweine;end;
						if objectTable.numHase ~= nil then numAmountMod = objectTable.numHase;end;
						if objectTable.numLamm ~= nil then numAmountMod = objectTable.numLamm;end;					
						if numAmountMod ~= nil and numAmountMod >= 0.9 then	
							moFillTypes[k].siloAmount[farmSilo] = numAmountMod;
							foundFillAnimal = true;
							break;
						end;
					end;
				end;
				if foundFillAnimal then return true;end;
			end;
		end;			
	end;
	if desc.name == "silage" then		
		if not moGuiMiniPdaSlots.separatedAmount then 
			if moBGA.fill ~= 0 then			
				if moFillTypes[k].siloAmount[farmSilo] ~= 0 then moFillTypes[k].siloAmount[farmSilo] = moBGA.fill+moFillTypes[k].siloAmount[farmSilo];end;
				if moFillTypes[k].siloAmount[farmSilo] == 0 then moFillTypes[k].siloAmount[farmSilo] = moBGA.fill;end;
				return true;			
			end;
		end;		
	end;
	if desc.name == "fuel" then 
		if moGeneralSettings.gasStation and table.getn(g_currentMission.gasStations) > 0 then
			local fuelAmount = 0;
			for a, b in pairs(g_currentMission.gasStations) do
				if b ~= nil and b.rootNode ~= nil and b.maxFuel > -1 then
					local fuelAmountMod = Utils.getNoNil(b.fillLevel,0);
					fuelAmount = fuelAmount+fuelAmountMod;
				end;
			end;			
			--new fix fuel double			
			amount = 0;
			if not moGeneralSettings.fruitsDoubleNames then
				local splitFuelFruits = Utils.splitString(" ", moGeneralSettings.fuelFruits);
				setTotalAmount(splitFuelFruits, desc.name);
			end;
			moFillTypes[k].siloAmount[farmSilo] = amount+fuelAmount;				
			if amount+fuelAmount > 0.9 then return true;else return false;end;
			--new fix fuel double			
		elseif not moGeneralSettings.fruitsDoubleNames then
			amount = 0;
			local splitFuelFruits = Utils.splitString(" ", moGeneralSettings.fuelFruits);
			setTotalAmount(splitFuelFruits, desc.name);
			moFillTypes[k].siloAmount[farmSilo] = amount;				
			if amount > 0.9 then return true;else return false;end;			
		end;
	end;
	if desc.name == "manure" then
		if not moGuiMiniPdaSlots.separatedAmount then
			local manureAmount = 0;		
			if animals ~= nil then			
				if animals.cow ~= nil and animals.cow.manureHeap ~= nil then
					local manureAmountCow = Utils.getNoNil(animals.cow.manureHeap.fillLevel,0);
					manureAmount = manureAmount+manureAmountCow;				
					--moFillTypes[k].siloAmountCow = manureAmountCow;
				end;
				if string.len(moGeneralSettings.foundAnimals) > 1 and #moMapObjects.sr > 0 then
					for a=1, #moMapObjects.sr do
						if moMapObjects.sr[a] ~= nil then
							local objectTable = moMapObjects.sr[a];
							if objectTable.manureHeap ~= nil then
								local manureAmountMod = Utils.getNoNil(objectTable.manureHeap.FillLvl,0);
								manureAmount = manureAmount+manureAmountMod;
							end;
						end;
					end;
				end;
				if not moGeneralSettings.fruitsDoubleNames then
					local splitManureFruits = Utils.splitString(" ", moGeneralSettings.manureFruits);				
					amount = 0;
					setTotalAmount(splitManureFruits, desc.name);					
				end;
				manureAmount = manureAmount+amount;
				if manureAmount >= 0.9 then				
					moFillTypes[k].siloAmount[farmSilo] = manureAmount;				
					return true;
				end;
			elseif not moGeneralSettings.fruitsDoubleNames then
				amount = 0;
				local splitManureFruits = Utils.splitString(" ", moGeneralSettings.manureFruits);
				setTotalAmount(splitManureFruits, desc.name);
				moFillTypes[k].siloAmount[farmSilo] = amount;				
				if amount > 0.9 then return true;else return false;end;
			end;
		elseif not moGeneralSettings.fruitsDoubleNames then
			amount = 0;
			local splitManureFruits = Utils.splitString(" ", moGeneralSettings.manureFruits);
			setTotalAmount(splitManureFruits, desc.name);
			moFillTypes[k].siloAmount[farmSilo] = amount;				
			if amount > 0.9 then return true;else return false;end;
		end;
	end;
	if desc.name == "liquidManure"then
		if not moGuiMiniPdaSlots.separatedAmount then
			local liquidManureAmount = 0;							
			if animals ~= nil then
				if animals.cow ~= nil and animals.cow.liquidManureTrigger ~= nil then
					local liquidManureAmountCow = Utils.getNoNil(animals.cow.liquidManureTrigger.fillLevel,0);
					liquidManureAmount = liquidManureAmount+liquidManureAmountCow;
					--moFillTypes[k].siloAmountCow = liquidManureAmountCow;
				end;
				if string.len(moGeneralSettings.foundAnimals) > 1 and #moMapObjects.sr > 0 then
					for a=1, #moMapObjects.sr do
						if moMapObjects.sr[a] ~= nil then
							local objectTable = moMapObjects.sr[a];
							if objectTable.liquidManureSiloTrigger ~= nil then
								local liquidManureAmountMod = Utils.getNoNil(objectTable.liquidManureSiloTrigger.fillLevel,0);
								liquidManureAmount = liquidManureAmount+liquidManureAmountMod;
							end;
						end;
					end;				
				end;
				if not moGeneralSettings.fruitsDoubleNames then
					local splitLiquidFruits = Utils.splitString(" ", moGeneralSettings.liquidFruits);				
					amount = 0;
					setTotalAmount(splitLiquidFruits, desc.name);								
				end;
				liquidManureAmount = liquidManureAmount+amount;
				if liquidManureAmount >= 0.9 then
					moFillTypes[k].siloAmount[farmSilo] = liquidManureAmount;			
					return true;
				end;
			elseif not moGeneralSettings.fruitsDoubleNames then
				local splitLiquidFruits = Utils.splitString(" ", moGeneralSettings.liquidFruits);				
				amount = 0;
				setTotalAmount(splitLiquidFruits, desc.name);
				moFillTypes[k].siloAmount[farmSilo] = amount;				
				if amount > 0.9 then return true;else return false;end;
			end;
		elseif not moGeneralSettings.fruitsDoubleNames then
			local splitLiquidFruits = Utils.splitString(" ", moGeneralSettings.liquidFruits);				
			amount = 0;
			setTotalAmount(splitLiquidFruits, desc.name);
			moFillTypes[k].siloAmount[farmSilo] = amount;				
			if amount > 0.9 then return true;else return false;end;
		end;
	end;	
	if amount >= 0.9 then return true;end;
	return false
end;

function moSetGetAmount:getNoFoundBaleAmount(self)	
	moBaleTypes = {};
	function setBaleTable(baleType)
		if moBaleTypes[baleType] == nil then
			moBaleTypes[baleType] = {};
			moBaleTypes[baleType].name = baleType;
			moBaleTypes[baleType].amount = 1;
		else
			moBaleTypes[baleType].amount = moBaleTypes[baleType].amount+1;
		end;
	end;
	if MultiOverlayV2.isMp and not MultiOverlayV2.loadHostServer and MultiOverlayV2.event.itemToSave_s and moFillableItemToServer ~= nil then
		for a, mapFillablePal in pairs(moFillableItemToServer) do
		--for a=1, #moFillableItemToServer do
			if moFillableItemToServer[a] ~= nil then				
				if moFillableItemToServer[a].className == "Bale" then					
					local fillType = Utils.getNoNil(moFillableItemToServer[a].fillType, 0);
					local desc = Fillable.fillTypeIndexToDesc[fillType];
					baleType = "Unknow"
					if desc ~= nil then				
						baleType = moFillTypes[desc.index].fruitName;
						setBaleTable(baleType);
					else
						setBaleTable(baleType);
					end;
				end;
			end;
		end;
	else
		for key,value in pairs(g_currentMission.itemsToSave) do
			if value.item.className ~= nil and value.item.className == "Bale" then
				local desc = Fillable.fillTypeIndexToDesc[key.fillType];
				baleType = "Unknow"
				if desc ~= nil then				
					baleType = moFillTypes[desc.index].fruitName;
					setBaleTable(baleType);
				else
					setBaleTable(baleType);
				end;			
			end;
		end;
	end;	
end;

function moSetGetAmount:getNoItemAmount(self, fruit, itemClass)
	local fillLevel = 0;
	local pal = 0;
	if MultiOverlayV2.isMp and not MultiOverlayV2.loadHostServer and MultiOverlayV2.event.itemToSave_s and moFillableItemToServer ~= nil then
		for a, mapFillablePal in pairs(moFillableItemToServer) do
		--for a=1, #moFillableItemToServer do
			if moFillableItemToServer[a] ~= nil then				
				if moFillableItemToServer[a].className == itemClass then
					local fillType = Utils.getNoNil(moFillableItemToServer[a].fillType, 0);
					local desc = Fillable.fillTypeIndexToDesc[fillType];
					if desc ~= nil and moPalFillTypes[fillType] == nil then moPalFillTypes[fillType] = {};end;
					if desc ~= nil and fillType == fruit then
						fillLevel = fillLevel+Utils.getNoNil(moFillableItemToServer[a].fillLevel, 0);
						pal = pal+1;
					end;
				end;
			end;
		end;
	else
		for key,value in pairs(g_currentMission.itemsToSave) do		
			if value.item.className ~= nil and value.item.className == itemClass then
				local desc = Fillable.fillTypeIndexToDesc[key.fillType];
				if desc ~= nil and moPalFillTypes[key.fillType] == nil then moPalFillTypes[key.fillType] = {};end;
				if desc ~= nil and key.fillType == fruit then
					fillLevel = fillLevel+key.fillLevel
					pal = pal+1;
				end;			
			end;
		end;
	end;
	return fillLevel, pal;	
end;
